﻿/*
* Hot Joomla Templates - jQuery Gallery - HOT DESIGNATION 1.2.1
*
* Copyright 2011,(http://www.hotjoomlatemplates.com)
*
*
* Depends:
*	jquery.ui.core.js
*	jquery.ui.widget.js
*/
(function (jQuery, undefined) {
    jQuery.widget("hjt.hjtgallery", {
        options: {
            displayListItems: 3,
            startTimeout: 500,
            fadeTimeout: 1000,
            slideTimeout: 10000,
			thumbPosition: 'left', // left|right
            repeatSlideShow: 1,
            swapItemsTimeout: 1500,
            imgDir: 'HJT/css/images',
            displayPosition: 'right', //'left'|'right'
            arrowWidth: '48px',
            arrowHeight: '34px',
            leftArrowOffset: 10,
            rightArrowOffset: -10,
            hightlight: ['design'],
            starsPosition: 'bottom', //'top'|'bottom'
            starsOffset: '0 0',
            starsDistance: 6,
            easing: 'swing', //linear|swing|easeInQuad|easeOutQuad|easeInOutQuad|easeInCubic|easeOutCubic|easeInOutCubic|easeInQuart|easeOutQuart|easeInOutQuart|easeInQuint|easeOutQuint|easeInOutQuint|easeInSine|easeOutSine|easeInOutSine|easeInExpo|easeOutExpo|easeInOutExpo|easeInCirc|easeOutCirc|easeInOutCirc|easeInElastic|easeOutElastic|easeInOutElastic|easeInBack|easeOutBack|easeInOutBack|easeInBounce|easeOutBounce|easeInOutBounce
            useSidePoiters: true
        },
        _BaseHTML: "",
        _Container: null,
        _InnerElements: null,
        _ItemsListContainer: null,
        _ItemsList: null,
        _View: null,
        _ViewArray: null,
        _SideItemArray: null,
        _SideContainer: null,
        _SeparattorArray: null,
        _Cursor: -1,
        _cmdLeft: null,
        _cmdRight: null,
        _PrevIndex: -1,
        _StarsArray: null,
        _StarsContainer: null,
        _SlideShowRun: 1,
        _LeftScrollerPointer: null,
        _RightScrollerPointer: null,
        _create: function () {
            var self = this,
			    options = self.options;
            var el = jQuery(this.element);
            el.hide();
            this._InnerElements = el.children(); // CUVAMO ORIGINALNI HTML
            this._BaseHTML = el.html();
            this._Container = el;

            this._ViewArray = new Array();
            this._SideItemArray = new Array();
            this._SeparattorArray = new Array();
            this._StarsArray = new Array();

            var n = 0;
            var ImageState = 0;
            var ItmA = this._SideItemArray;
            var ImgA = this._ViewArray;
            var Details;
            this._InnerElements.each(function (index) {
                switch (jQuery(this).get(0).tagName.toUpperCase()) {
                    case ("DIV"):
                    case ("IMG"):
                        if (ImageState == 0) {
                            ItmA[n] = jQuery("<tr class='hjt-gallery-list-item'></tr>");
                            var ThumbTD = jQuery("<td class='hjt-gallery-list-item-thumb'></td>");
                            Details = jQuery("<td class='hjt-gallery-list-item-content'></td>");
                            ThumbTD.append(jQuery(this));
                            if(self.options.thumbPosition == 'right')
							    ItmA[n].append(Details).append(ThumbTD);
	                        else 
							    ItmA[n].append(ThumbTD).append(Details);
						    ImageState = 1;
                        } else {
                            ImgA[n] = jQuery(this);
                            ImageState = 0;
                        }
                        break;
                    case ("HR"):
                        n++;
                        break;
                    case ("H3"):
                        if (self.options.hightlight == undefined || self.options.hightlight == null || self.options.hightlight == '') {
                            //
                        }
                        else if (self.options.hightlight.constructor.toString().indexOf("Array") == -1) {
                            jQuery(this).html(jQuery(this).text().replace(new RegExp(self.options.hightlight,"ig"), "<span class='hjt-hightlight'>" + self.options.hightlight + "</span>"));
                        }
                        else {
						    var j=0;
						    while(j < self.options.hightlight.length){
							 jQuery(this).html(jQuery(this).text().replace(new RegExp(self.options.hightlight[j],"ig"), "<span class='hjt-hightlight'>" + self.options.hightlight[j] + "</span>"));
							 j++;
							} 
						}
                        jQuery(this).prepend("<div class='hjt-item-arrow'></div>");
                        Details.append(jQuery(this));
                        break;
                    default:
                        try {
                            Details.append(jQuery(this));
                        } catch (exc) { }
                        break;
                }
            });

            el.html("")
              .addClass("hjt-gallery-container")
              .append(jQuery(
                  "<table cellpadding='0' cellspacing='0'><tr>"
                + ((self.options.displayPosition == 'left') ?
                    "<td class='hjt-gallery-image-view-container'></td><td class='hjt-gallery-list-container'></td>"
                  : "<td class='hjt-gallery-list-container'></td><td class='hjt-gallery-image-view-container'></td>")
                + "<tr><table>"));


            this._ItemsListContainer = jQuery("<div></div>");
            this._ItemsListContainer.addClass("hjt-gallery-list-slider");

            this._ItemsList = jQuery("<table cellpadding='0' cellspacing='0' ></table>");
            this._ItemsList.addClass("hjt-gallery-list");

            this._View = jQuery('<div></div>');
            this._View.addClass("hjt-gallery-image-view");

            this._cmdLeft = jQuery("<div class='hjt-gallery-cmd-left'><img src='" + self.options.imgDir + "/hjt_gallery_left.png' /></div>");
            this._cmdRight = jQuery("<div class='hjt-gallery-cmd-right'><img src='" + self.options.imgDir + "/hjt_gallery_right.png' /></div>");



            this._ItemsListContainer.append(this._ItemsList);
            jQuery(el.find('.hjt-gallery-list-container')[0]).append(this._ItemsListContainer);
            jQuery(el.find('.hjt-gallery-image-view-container')[0]).append(this._View);

            jQuery(el.find('.hjt-gallery-image-view-container')[0]).append(this._cmdLeft);
            jQuery(el.find('.hjt-gallery-image-view-container')[0]).append(this._cmdRight);



            var i = 0;
            while (i < n) {
                this._SideItemArray[i].bind('click', { ItemIndex: i, Controler: this }, this.onItem_Click);
                i++;
            }


            self._StarsContainer = jQuery("<div class='hjt-gallery-stars-container' ></div>");
            self._StarsContainer.appendTo(jQuery(el.find('.hjt-gallery-image-view-container')[0]));

            i = 0;
            while (i < this._SideItemArray.length) {
                this._StarsArray[i] = jQuery('<div class="hjt-star"></div>');
                this._StarsArray[i].click({ displayIndex: i }, function (arg) {
                    self._SlideShowRun = 0;
                    self._Container.find('.hjt-gallery-list-item-selected').removeClass('hjt-gallery-list-item-selected');
                    self._Container.find(".hjt-gallery-left-scroller-pointer, .hjt-gallery-right-scroller-pointer").hide();
                    var k, ContainerH = 0, PrevH = 0, ScrollToIndex = 0;
                    ScrollToIndex = arg.data.displayIndex - (arg.data.displayIndex % self.options.displayListItems);
                    for (k = 0; k < ScrollToIndex; k++) {
                        if (self._SideItemArray[k]) PrevH += self._SideItemArray[k].innerHeight();
                        if (self._SeparattorArray[k]) PrevH += self._SeparattorArray[k].innerHeight();
                    }

                    for (k = ScrollToIndex; k < ScrollToIndex + self.options.displayListItems; k++) {
                        if (self._SideItemArray[k]) ContainerH += self._SideItemArray[k].innerHeight();
                        if (k < ScrollToIndex + self.options.displayListItems - 1) if (self._SeparattorArray[k]) ContainerH += self._SeparattorArray[k].innerHeight();
                    }

                    self._ItemsList.animate({ top: String(-PrevH) + 'px' }, self.options.swapItemsTimeout, self.options.easing, function () {
                        if (self._ItemsListContainer.innerHeight() != ContainerH) self._ItemsListContainer.innerHeight(ContainerH);
                        self.DisplayImage(arg.data.displayIndex);
                    });

                });

                if (jQuery.browser.msie) {
                    if (jQuery.browser.version < 8) {
                        this._StarsArray[i].css({ 'float': "left" });
                    }
                }

                self._StarsContainer.append(this._StarsArray[i]);
                i++;
            }


            if (self.options.useSidePoiters) {
                self._LeftScrollerPointer = jQuery("<div class='hjt-gallery-left-scroller-pointer' ></div>");
                self._RightScrollerPointer = jQuery("<div class='hjt-gallery-right-scroller-pointer' ></div>");
                el.append(self._LeftScrollerPointer)
                  .append(self._RightScrollerPointer);
            }

            jQuery(document).ready(function () {
                self._StarsContainer.innerWidth(self._View.innerWidth());
                jQuery(self._ViewArray).each(function (ind) {
                    if (self._ViewArray[ind]) {
                        self._ViewArray[ind].css({ 'position': 'absolute' });
                        self._View.append(self._ViewArray[ind]);
                        if (ind != 0) self._ViewArray[ind].hide();
                    }
                });

                self.PositionStarsContainer(self);

                if (self.options.useSidePoiters && self._SideItemArray[0]) {
                    self.PositionSidePointers(self,0);
                }
            });

            this._cmdLeft.bind('click', { Controler: this }, this.onCmdLeft_Click);
            this._cmdRight.bind('click', { Controler: this }, this.onCmdRight_Click);

            el.show(options.startTimeout);

            n = 0;
            var newHeight = 0;
            while (n < this._SideItemArray.length) {
                if ((this._SideItemArray[n] != undefined) ||
                            (this._SideItemArray[n] != null) ||
                            (this._SideItemArray[n] != '')) {
                    if (jQuery.browser.opera) {
                        this._ItemsList.append(this._SideItemArray[n]);
                        if (n < this.options.displayListItems) newHeight += this._SideItemArray[n].innerHeight();

                        this._SeparattorArray[n] = jQuery("<tr><td class='hjt-gallery-list-item-sppliter' colspan= '2'></td></tr>");
                        this._ItemsList.append(this._SeparattorArray[n]);
                        if (n % this.options.displayListItems != (this.options.displayListItems - 1)) {
                            if (n < this.options.displayListItems) newHeight += this._SeparattorArray[n].innerHeight();
                        }
                    }
                    else {
                        this._ItemsList.append(this._SideItemArray[n]);
                        if (n < this.options.displayListItems) newHeight += this._SideItemArray[n].height();

                        this._SeparattorArray[n] = jQuery("<tr><td class='hjt-gallery-list-item-sppliter' colspan= '2'></td></tr>");
                        this._ItemsList.append(this._SeparattorArray[n]);
                        if (n % this.options.displayListItems != (this.options.displayListItems - 1)) {
                            if (n < this.options.displayListItems) newHeight += this._SeparattorArray[n].height();
                        }
                    }
                }
                n++;
            }
			
            if (n > 0){
			  jQuery(document).ready(function(){
			    self.PositionStarsContainer(self);
				self.DisplayImage(0);
			  });
			} 
			
			jQuery(window).resize(function(){
			   self.PositionStarsContainer(self);
			   self.PositionSidePointers(self,false);
			});

            if (this._ItemsListContainer.height() != newHeight) this._ItemsListContainer.height(newHeight);

            var VerticalArrowsPositon = this._View.innerHeight() / 2 + this._cmdLeft.innerHeight() / 2;
            this._cmdLeft.css({ height: this.options.arrowHeight, width: this.options.arrowWidth, top: "-" + VerticalArrowsPositon + "px", left: this.options.leftArrowOffset + "px" });
            this._cmdRight.css({ height: this.options.arrowHeight, width: this.options.arrowWidth, top: "-" + VerticalArrowsPositon + "px", left: this.options.rightArrowOffset + "px" });



            try {
                if (this._SlideShowRun == 1) {
                    window.setInterval(function () {
                        if (self._SlideShowRun != 1) return;
                        if (self._Cursor == self._SideItemArray.length - 1) {
                            if (self.options.repeatSlideShow == 1) self._Cursor = -1;
                        }
                        self.Next();
                    }, this.options.slideTimeout);
                }
            } catch (ex) { this._Cursor = -1; }
		 },

        _setOption: function (key, value) {
            this.options[key] = value;
        },

        onItem_Click: function (eArgs) {
            var Self = eArgs.data.Controler;
            var Index = eArgs.data.ItemIndex;
            Self._SlideShowRun = 0;
            Self.DisplayImage(Index);
        },

        onCmdLeft_Click: function (eArgs) {
            var Self = eArgs.data.Controler;
            Self._SlideShowRun = 0;
            Self.Prev();
        },

        onCmdRight_Click: function (eArgs) {
            var Self = eArgs.data.Controler;
            Self._SlideShowRun = 0;
            Self.Next();
        },

        DisplayImage: function (Index) {
            var Self = this;
            var i = 0;
            Self._Container.find(".hjt-gallery-list-item-selected").each(function () { jQuery(this).removeClass("hjt-gallery-list-item-selected"); });
            Self._Container.find(".hjt-gallery-left-scroller-pointer, .hjt-gallery-right-scroller-pointer").hide();
            if (Index == Self._PrevIndex) return;
            if ((Index < 0) || (Index >= Self._ViewArray.length)) {
                if (Self._PrevIndex != -1) {
                    var Old = Self._ViewArray[Self._PrevIndex];
                    Old.fadeOut(Self.options.fadeTimeout, function () {
                        Old.hide();
                    });
                    //Self._SideItemArray[Self._PrevIndex].removeClass("hjt-gallery-list-item-selected");
                    Self._Cursor = -1;
                }
            }
            else {
                if (Self._PrevIndex == -1) {
				    Self._ViewArray[Index].hide();
                    Self._ViewArray[Index].fadeIn(Self.options.fadeTimeout);
                }
                else {
                    var Old = Self._ViewArray[Self._PrevIndex];
                    Old.fadeOut(Self.options.fadeTimeout, function () {
                        Old.hide();
                    });
                    Self._ViewArray[Index].hide();
                    Self._ViewArray[Index].fadeIn(Self.options.fadeTimeout);
                }

                if (Self._PrevIndex != -1) {
                    //Self._SideItemArray[Self._PrevIndex].removeClass("hjt-gallery-list-item-selected");
                }
                Self._PrevIndex = Index;
                Self._Cursor = Index;
                Self._SideItemArray[Index].addClass("hjt-gallery-list-item-selected");
                while (i < Self._SideItemArray.length) {
                    if (Self._Cursor == i)
                        Self._StarsArray[i].addClass('hjt-star-selected').removeClass('hjt-star');
                    else
                        Self._StarsArray[i].addClass('hjt-star').removeClass('hjt-star-selected');
                    i++;
                } //-while
            }
			
			Self.PositionSidePointers(Self,Index);
            
        },
		PositionStarsContainer: function(self){
		    var offsetL = self.options.starsOffset.split(' ')[0];
			var offsetT = self.options.starsOffset.split(' ')[1];
			offsetL = parseInt(offsetL); 
			offsetT = parseInt(offsetT);
		    if(String(offsetL) == 'NaN') offsetL = 0;
			if(String(offsetT) == 'NaN') offsetT = 0;
		    
		    self._StarsContainer.css({
			  'left': String(self._View.parent().offset().left + offsetL) + 'px' ,
			  'top': ( self.options.starsPosition.toLowerCase() == "top" 
			           ? String(self._View.parent().offset().top + offsetT) + 'px'
			           : String(self._View.parent().offset().top + offsetT + self._View.parent().innerHeight() - self._StarsContainer.innerHeight()) + 'px'
					 )
			});
		},
		PositionSidePointers: function(Self,Index){
		    if(!Index){
			  Index = 0;
			  var stop = false;
			  Self._ItemsListContainer.find('.hjt-gallery-list-item').each(function(i){
			    if(!stop){
					if(jQuery(this).hasClass('hjt-gallery-list-item-selected')){
					  stop = true;
					}else 
						Index++;
				}
			  });
			} 
		
		    if (Self.options.useSidePoiters && Self._SideItemArray[Index]) {
                var ScrollToIndex = Index - (Index % Self.options.displayListItems);
                var vOff = 0;
                for (i = 0; i < Index % Self.options.displayListItems; i++) {
                    if (Self._SideItemArray[ScrollToIndex + i]) vOff += Self._SideItemArray[ScrollToIndex + i].innerHeight();
                    if (Self._SeparattorArray[ScrollToIndex + i]) vOff += Self._SeparattorArray[ScrollToIndex + i].innerHeight();
                }
                Self._LeftScrollerPointer.css(
				{'top' : String(Self._ItemsListContainer.offset().top + vOff + ((Self._SideItemArray[Index].innerHeight() - Self._LeftScrollerPointer.innerHeight()) / 2)) + 'px',
				 'left' : String(Self._ItemsListContainer.offset().left - Self._LeftScrollerPointer.innerWidth()) + 'px'
				});
                Self._RightScrollerPointer.css(
				{'top' : String(Self._ItemsListContainer.offset().top + vOff + ((Self._SideItemArray[Index].innerHeight() - Self._RightScrollerPointer.innerHeight()) / 2)) + 'px',
				 'left' : String(Self._ItemsListContainer.offset().left + Self._ItemsListContainer.innerWidth()) + 'px'
				});
                Self._Container.find(".hjt-gallery-left-scroller-pointer, .hjt-gallery-right-scroller-pointer").show();
            }
		},
        Next: function () {
            var Self = this;
            if (this._Cursor == this._SideItemArray.length - 1) return;
            Self._Container.find(".hjt-gallery-list-item-selected").each(function () { jQuery(this).removeClass("hjt-gallery-list-item-selected"); });
            Self._Container.find(".hjt-gallery-left-scroller-pointer, .hjt-gallery-right-scroller-pointer").hide();

            this._Cursor++;
            if (this._Cursor < this._SideItemArray.length) {

                if (this._Cursor % this.options.displayListItems == 0) {
                    var n = 0;

                    var preHeight = 0;
                    while (n < this._Cursor) {
                        if ((this._SideItemArray[n] != undefined) ||
                            (this._SideItemArray[n] != null) ||
                            (this._SideItemArray[n] != '')) {

                            if (jQuery.browser.opera) {
                                preHeight += this._SideItemArray[n].innerHeight();
                                preHeight += this._SeparattorArray[n].innerHeight();
                            }
                            else {
                                preHeight += this._SideItemArray[n].height();
                                preHeight += this._SeparattorArray[n].height();
                            }
                        }
                        n++;
                    }

                    n = 0;
                    var newHeight = 0;
                    while (n < this.options.displayListItems) {

                        if ((this._SideItemArray[this._Cursor + n] != undefined) ||
                            (this._SideItemArray[this._Cursor + n] != null) ||
                            (this._SideItemArray[this._Cursor + n] != '')) {
                            if (this._Cursor + n < this._SideItemArray.length) {
                                if (jQuery.browser.opera) {
                                    newHeight += this._SideItemArray[this._Cursor + n].innerHeight();
                                    if (n != this.options.displayListItems - 1) {
                                        newHeight += this._SeparattorArray[this._Cursor + n].innerHeight();
                                    }
                                }
                                else {
                                    newHeight += this._SideItemArray[this._Cursor + n].height();
                                    if (n != this.options.displayListItems - 1) {
                                        newHeight += this._SeparattorArray[this._Cursor + n].height();
                                    }
                                }

                            }
                        }
                        n++;
                    }


                    if (this._ItemsListContainer.height() < newHeight) this._ItemsListContainer.height(newHeight);
                    if (preHeight != Number(this._ItemsList.css('top').replace('px', ''))) {
                        this._ItemsList.animate({ top: String(-preHeight) + 'px' }, this.options.swapItemsTimeout, this.options.easing, function () {
                            if (Self._ItemsListContainer.height() != newHeight) Self._ItemsListContainer.height(newHeight);
                            Self.DisplayImage(Self._Cursor);
                        });
                    } else {
                        if (this._ItemsListContainer.height() != newHeight) this._ItemsListContainer.height(newHeight);
                        this.DisplayImage(this._Cursor);
                    }
                } else {
                    this.DisplayImage(this._Cursor);
                }
            }

        },

        Prev: function () {
            var Self = this;
            if (this._Cursor == 0) return;
            Self._Container.find(".hjt-gallery-list-item-selected").each(function () { jQuery(this).removeClass("hjt-gallery-list-item-selected"); });
            Self._Container.find(".hjt-gallery-left-scroller-pointer, .hjt-gallery-right-scroller-pointer").hide();
            this._Cursor--;
            if (this._Cursor >= 0) {
                if (this._Cursor % this.options.displayListItems == this.options.displayListItems - 1) {
                    var n = 0;

                    var preHeight = 0;
                    while (n < this._Cursor - this.options.displayListItems + 1) {
                        if ((this._SideItemArray[n] != undefined) ||
                            (this._SideItemArray[n] != null) ||
                            (this._SideItemArray[n] != '')) {
                            if (jQuery.browser.opera) {
                                preHeight += this._SideItemArray[n].innerHeight();
                                preHeight += this._SeparattorArray[n].innerHeight();
                            }
                            else {
                                preHeight += this._SideItemArray[n].height();
                                preHeight += this._SeparattorArray[n].height();
                            }

                        }
                        n++;
                    }


                    n = 0;
                    var newHeight = 0;
                    while (n < this.options.displayListItems) {
                        if ((this._SideItemArray[this._Cursor - this.options.displayListItems + n + 1] != undefined) ||
                            (this._SideItemArray[this._Cursor - this.options.displayListItems + n + 1] != null) ||
                            (this._SideItemArray[this._Cursor - this.options.displayListItems + n + 1] != '')) {
                            if (jQuery.browser.opera) {

                                newHeight += this._SideItemArray[this._Cursor - this.options.displayListItems + n + 1].innerHeight();
                                if ((this._Cursor - this.options.displayListItems + n + 1) % this.options.displayListItems != this.options.displayListItems - 1) {
                                    newHeight += this._SeparattorArray[this._Cursor - this.options.displayListItems + n + 1].innerHeight();
                                }
                            }
                            else {
                                newHeight += this._SideItemArray[this._Cursor - this.options.displayListItems + n + 1].height();
                                if ((this._Cursor - this.options.displayListItems + n + 1) % this.options.displayListItems != this.options.displayListItems - 1) {
                                    newHeight += this._SeparattorArray[this._Cursor - this.options.displayListItems + n + 1].height();
                                }
                            }
                        }
                        n++;
                    }

                    var ILCH = this._ItemsListContainer.height();
                    if (jQuery.browser.opera) {
                        ILCH = this._ItemsListContainer.innerHeight();
                    }

                    if (ILCH < newHeight) this._ItemsListContainer.height(newHeight);
                    if (preHeight != Number(this._ItemsList.css('top').replace('px', ''))) {
                        this._ItemsList.animate({ top: String(-preHeight) + 'px' }, this.options.swapItemsTimeout, this.options.easing, function () {
                            if (ILCH != newHeight) Self._ItemsListContainer.height(newHeight);
                            Self.DisplayImage(Self._Cursor);
                        });
                    } else {
                        if (ILCH != newHeight) this._ItemsListContainer.height(newHeight);
                        this.DisplayImage(this._Cursor);
                    }

                } else {
                    this.DisplayImage(this._Cursor);
                }
            }
        },

        SlideShowRun: function (state) {
            if (this._SlideShowRun == 0 && state != 0) {
                this._SlideShowRun = state;
                this.Next();
            }
            else {
                this._SlideShowRun = state;
            }
        },

        destroy: function () {
            jQuery(this.element).html(this._baseHTML);
            jQuery.Widget.prototype.destroy.call(this);
        }


    }); // widget
})(jQuery);
